/**********************************************************************
 * $Id: LTIImageStage.java,v 1.6 2006/01/09 12:23:12 nacho Exp $
 *
 * Name:     LTIImageStage.java
 * Project:  JMRSID. Interface java to mrsid (Lizardtech).
 * Purpose:   
 * Author:   Nacho Brodin, brodin_ign@gva.es
 *
 **********************************************************************/
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/

package es.gva.cit.jmrsid;


/**
 * Clase que aade funcionalidad para la decodificacin desde una imagen.
 * @author Nacho Brodin <brodin_ign@gva.es>.<BR> Equipo de desarrollo gvSIG.<BR> http://www.gvsig.gva.es
 * @version 0.0
 * @link http://www.gvsig.gva.es
 */
public class LTIImageStage extends LTIImage{
	
	
	private native int readNat(long cPtr, long cPtrscene, long cPtrobj_scenebuffer, long cPtrbuffer, LTISceneBuffer buffer);
	private native void FreeLTIImageStageNat(long cPtr);
	
	public LTIImageStage(){}
	
	/**
	 * Constructor
	 * @param cPtr	direccin de memoria al objeto LTIImageStage de C. 
	 */
	public LTIImageStage(long cPtr){
		this.cPtr=cPtr;
	}
	
	/**
	 * Destructor 
	 */
	protected void finalize(){
		if(cPtr > 0)
			FreeLTIImageStageNat(cPtr);
	}
	
	/**
	 * Lee una escena desde una imagen.
	 * @throws MrSIDException
	 * @param scene	Objeto escena a leer
	 * @param buffer	buffer sobre el cual se almacenan los datos leidos
	 */
	public void read(LTIScene scene,LTISceneBuffer buffer)throws MrSIDException{

		if(scene==null || buffer==null)
			throw new MrSIDException("Los argumentos no pueden ser nulos");
		
		int res=readNat(cPtr,scene.cPtr,buffer.cPtr,buffer.cPtrbuffer, buffer);
		
		if(res!=0)
			throw new MrSIDException("En el mtodo read se ha devuelto un cdigo "+res);
		
	}
	
}